//////////////////////////////////////////////////
// 2006/02/14
//  
//////////////////////////////////////////////////


#define STRICT
#include <windows.h>

#include <vector>
#include <string>
#include <fstream>

#include "resource.h"


const LPCTSTR className = "TaskTrayLauncherByMuraseMasamitsu";
const char *helpfileName = "TTLHelp.chm";
const unsigned int max_length = 20;
std::vector< std::string > add_program_title(0);
std::vector< HWND > add_program_hwnd(0);
std::vector< int > add_program_state(0);


LRESULT CALLBACK WndProc (HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam);
BOOL DeleteTaskTrayIcon(HWND hwnd);
BOOL AddTaskTrayIcon(HWND hwnd);
void ShowTaskTrayMenu(HWND hwnd, HMENU hmenu);
HMENU CreatePopupMenu(HWND hwnd);
void ShowAllWindowAdded();
bool RegisterHiddenWindow(HWND hwnd);
void ShowWindowAdded(int index);
void ShowHelp(HWND hwnd);



int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdLine, int iCmdShow)
{
  HANDLE hMutex = CreateMutex(NULL, TRUE, className);
  if (hMutex==NULL){
    return FALSE;
  }
  if (GetLastError()==ERROR_ALREADY_EXISTS){
    return FALSE;
  }

  WNDCLASSEX wndclass;
  wndclass.cbSize        = sizeof(wndclass);        //\̂̑傫
  wndclass.style         = CS_HREDRAW | CS_VREDRAW; //X^C
  wndclass.lpfnWndProc   = WndProc;                 //bZ[W֐
  wndclass.cbClsExtra    = 0;
  wndclass.cbWndExtra    = 0;
  wndclass.hInstance     = hInstance;               //vÕnh
  wndclass.hIcon         = LoadIcon(hInstance, "MY_MAIN_ICON"); //ACR
  wndclass.hCursor       = LoadCursor(NULL, IDC_ARROW);     //J[\
  wndclass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH); //uV
  wndclass.lpszMenuName  = NULL;              //j[
  wndclass.lpszClassName = className;   //NX
  wndclass.hIconSm       = LoadIcon(hInstance, "MY_MAIN_ICON2");
  

  if (RegisterClassEx(&wndclass)==0){
    return FALSE;
  }

  HWND hwMain = CreateWindow(className, "Task Tray Launcher", WS_OVERLAPPEDWINDOW, 
                             32, 32, 512, 128, NULL, NULL, hInstance, NULL);

  ShowWindow(hwMain, SW_HIDE); //EChE\
//  ShowWindow(hwMain, SW_NORMAL); //EChE\
  UpdateWindow (hwMain);        //ĕ`

  MSG msg;
  while(GetMessage(&msg, NULL, 0, 0)>0){  //bZ[W[v
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }

  return msg.wParam ;
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
  static HMENU hmenu; //|bvAbvj[ێ
  static UINT taskbar_restart; //ExploreċNƂ̂߁B

  switch(iMsg){
  case WM_CREATE:
    AddTaskTrayIcon(hwnd);
    hmenu = CreatePopupMenu(hwnd);
    taskbar_restart = RegisterWindowMessage(TEXT("TaskbarCreated"));
    break;
  case WM_COMMAND: //j[NbNꂽƂ
    switch(LOWORD(wParam)){
    case ID_MENU_HELP:
      ShowHelp(hwnd);
      break;
    case ID_MENU_END:
      SendMessage(hwnd, WM_CLOSE, 0, 0);
      break;
    case ID_MENU_ALL_SHOW_ADDED:
      ShowAllWindowAdded();
      DestroyMenu(hmenu);
      hmenu = CreatePopupMenu(hwnd);
      break;
    case ID_MENU_ADD_PROGRAM:
      if (RegisterHiddenWindow(hwnd)==true){
        DestroyMenu(hmenu);
        hmenu = CreatePopupMenu(hwnd);
      }
      break;
    default:
      int index = LOWORD(wParam) - ID_MENU_ADD_PROGRAM_START;
      ShowWindowAdded(index);
      DestroyMenu(hmenu);
      hmenu = CreatePopupMenu(hwnd);
      break;
    }
    break;
  case WM_USER: //^XNgC̃ACRNbNꂽƂ
    if (lParam==WM_LBUTTONUP){
      ShowTaskTrayMenu(hwnd, hmenu);
    }
    break;
  case WM_CLOSE:
    ShowAllWindowAdded();
    DeleteTaskTrayIcon(hwnd);
    DestroyMenu(hmenu);
    break;
  case WM_DESTROY:
    PostQuitMessage(0);
    return 0;
  default:
    if (iMsg==taskbar_restart){
      AddTaskTrayIcon(hwnd);
    }
    break;
  }

  return DefWindowProc(hwnd, iMsg, wParam, lParam);
}

BOOL AddTaskTrayIcon(HWND hwnd)
{
  //^XNgCɒǉACR̃nh擾
  HICON hIcon = LoadIcon((HINSTANCE)GetWindowLong(hwnd, GWL_HINSTANCE), "MY_MAIN_ICON2");

  //NOTIFYICONDATAݒ
  NOTIFYICONDATA icdata;
  icdata.cbSize = sizeof(NOTIFYICONDATA);
  icdata.hWnd = hwnd;
  icdata.uID = 0;
  icdata.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
  icdata.uCallbackMessage = WM_USER;
  icdata.hIcon = hIcon;
  strcpy(icdata.szTip, "TaskTrayLauncher");

  //^XNgCɃACRǉ
  return Shell_NotifyIcon(NIM_ADD, &icdata);
}

BOOL DeleteTaskTrayIcon(HWND hwnd)
{
  //NOTIFYICONDATA̐ݒ
  NOTIFYICONDATA icdata;
  icdata.cbSize = sizeof(NOTIFYICONDATA);
  icdata.hWnd = hwnd;
  icdata.uID = 0;
  icdata.uFlags = 0;

  //ACR폜
  return Shell_NotifyIcon(NIM_DELETE, &icdata);
}

void ShowTaskTrayMenu(HWND hwnd, HMENU hmenu)
{
  POINT pos;
  if (GetCursorPos(&pos)){
    SetForegroundWindow(hwnd);
    TrackPopupMenu(GetSubMenu(hmenu, 0), TPM_LEFTALIGN | TPM_TOPALIGN, pos.x, pos.y, 0, hwnd, NULL);
  }
}

HMENU CreatePopupMenu(HWND hwnd)
{
  HMENU hsubmenu = CreateMenu();
  int menucount = 0;
  InsertMenu(hsubmenu, menucount, MF_BYPOSITION | MF_STRING, ID_MENU_ADD_PROGRAM, "BEBhEI");
  menucount++;
  if (add_program_title.size()>0){
    HMENU hreview = CreateMenu();
    InsertMenu(hreview, 0, MF_BYPOSITION | MF_STRING, ID_MENU_ALL_SHOW_ADDED, "ׂĕ\\");
    InsertMenu(hreview, 1, MF_BYPOSITION | MF_STRING | MF_SEPARATOR, 0, "");
    for (unsigned int index=0; index<add_program_title.size(); index++){
      InsertMenu(hreview, index+2, MF_BYPOSITION | MF_STRING, ID_MENU_ADD_PROGRAM_START+index, 
                 add_program_title[index].c_str());
    }
    InsertMenu(hsubmenu, menucount, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT_PTR)hreview, "ĕ\\");
    menucount++;
  }

  InsertMenu(hsubmenu, menucount, MF_BYPOSITION | MF_SEPARATOR, 0, "");
  menucount++;
  InsertMenu(hsubmenu, menucount, MF_BYPOSITION | MF_STRING, ID_MENU_HELP, "wv");
  menucount++;
  InsertMenu(hsubmenu, menucount, MF_BYPOSITION | MF_STRING, ID_MENU_END, "I");
  menucount++;

  HMENU hmenu = CreateMenu();
  InsertMenu(hmenu, 0, MF_BYPOSITION | MF_POPUP, (UINT_PTR)hsubmenu, "_~[");
  DrawMenuBar(hwnd);
  return hmenu;
}

void ShowAllWindowAdded()
{
  for (unsigned int i=0; i<add_program_title.size(); i++){
    if (IsWindow(add_program_hwnd[i])==TRUE){
      ShowWindow(add_program_hwnd[i], add_program_state[i]);
    }
  }
  add_program_title.resize(0);
  add_program_hwnd.resize(0);
  add_program_state.resize(0);
}

bool RegisterHiddenWindow(HWND hwnd)
{
  DeleteTaskTrayIcon(hwnd);

  int ret = MessageBox(NULL, "\\ɂEBhȄփ}EXJ[\\ĂAEnterĂB",
                       "Task Tray Launcher", MB_OKCANCEL);

  if (ret==IDOK){
    POINT pos;
    GetCursorPos(&pos);
    HWND target = WindowFromPoint(pos);
    if (target!=NULL){
      HWND root = GetAncestor(target, GA_ROOT);
      char name[2048];
      if (root!=NULL){
        GetWindowText(root, name, 2048);
        std::string str("\"");
        str += name;
        str += "\"\\ɂ܂H";
        if (MessageBox(NULL, str.c_str(), "Task Tray Launcher", MB_YESNO)==IDYES){
          std::string name_str(name);
          if (name_str.length()>max_length){
            name_str.erase(name_str.begin()+max_length, name_str.end());
          }
          add_program_title.push_back(name_str);
          add_program_hwnd.push_back(root);
          if (IsZoomed(root)==TRUE){
            add_program_state.push_back(SW_MAXIMIZE);
          }else{
            add_program_state.push_back(SW_NORMAL);
          }
          ShowWindow(root, SW_HIDE);
          AddTaskTrayIcon(hwnd);
          return true;
        }
      }
    }
  }
  
  AddTaskTrayIcon(hwnd);
  return false;
}

void ShowWindowAdded(int index)
{
  if (IsWindow(add_program_hwnd[index])==TRUE){
    ShowWindow(add_program_hwnd[index], add_program_state[index]);
  }
  add_program_title.erase(add_program_title.begin()+index);
  add_program_hwnd.erase(add_program_hwnd.begin()+index);
  add_program_state.erase(add_program_state.begin()+index);
}

void ShowHelp(HWND hwnd)
{
  char path[MAX_PATH+1];
  int length = GetModuleFileName(NULL, path, MAX_PATH);
  if (length<=0){
    return;
  }
  int last;
  for (last = length-1; last>0; last--){
    if (path[last]=='\\'){
      break;
    }
  }
  last++;
  char help_path[MAX_PATH+1];
  strncpy(help_path, path, last);
  strcpy(help_path+last, helpfileName);

  int ret = (int)ShellExecute(NULL, NULL, help_path, NULL, NULL, SW_SHOWNORMAL);
  if (ret<=32){
    MessageBox(NULL, "wvt@C܂B", "Task Tray Launcher", MB_OK);
  }
}

